# Generated by go2rpm
%bcond_without check
%bcond_with bootstrap

%if %{with bootstrap}
%global debug_package %{nil}
%endif

# https://github.com/golang/tools
%global goipath         golang.org/x/tools
%global goipathsex      golang.org/x/tools/gopls
%global forgeurl        https://github.com/golang/tools
# This package should be split per go.mod
Version:                0.29.0

%gometa

%global common_description %{expand:
This package holds the source for various tools that support the Go programming
language.

Some of the tools, godoc and vet for example, are included in binary Go
distributions.

Others, including the Go guru and the test coverage tool, can be fetched with go
get.

Packages include a type-checker for Go and an implementation of the Static
Single Assignment form (SSA) representation for Go programs.}

%global golicenses      LICENSE PATENTS
%global godocs          CONTRIBUTING.md README.md

%global auth_commands authtest cookieauth gitauth netrcauth
%global commands benchcmp bisect bundle callgraph compilebench digraph eg file2fuzz fiximports go-contrib-init godex godoc goimports gomvpkg gonew gotype goyacc html2article present present2md splitdwarf ssadump stress stringer toolstash
%global signature_fuzzer fuzz-driver fuzz-runner

Name:           %{goname}
Release:        %mkrel 1
Summary:        Various packages and tools that support the Go programming language
Group:          Development/Golang
# Upstream license specification: BSD-3-Clause
# Automatically converted from old format: BSD - review is highly recommended.
License:        LicenseRef-Callaway-BSD
URL:            %{gourl}
Source0:        %{gosource}
# This test imports "all of tools", but we delete gopls in order to build it
# as a separate package. Thus this test can't work correctly, so remove it.
Patch:          0001-Don-t-try-to-import-all-of-tools.patch
# We can't use these tests since we run with GO111MODULE=off
Patch:          0002-Skip-tests-that-require-module-mode.patch

BuildRequires:  golang-tests

%description
%{common_description}

%if %{without bootstrap}
%package -n golang-godoc
Summary:        Documentation tool for the Go programming language
Epoch:          1
Obsoletes:      golang-godoc = 1.1.2

%description -n golang-godoc
Godoc extracts and generates documentation for Go programs.

%package -n golang-gotype
Summary:        Go programming language source code analysis tool

%description -n golang-gotype
The gotype command, like the front-end of a Go compiler, parses and type-checks
a single Go package. Errors are reported if the analysis fails; otherwise
gotype is quiet (unless -v is set).

%package -n golang-html2article
Summary:        Tool for creating articles from HTML files

%description -n golang-html2article
This program takes an HTML file and outputs a corresponding article file
in present format. See: golang.org/x/tools/present

%package        auth
Summary:        Tools implementing the GOAUTH protocol

%description    auth
%{summary}.

%package        bisect
Summary:        Tool to find changes responsible for causing a failure

%description    bisect
%{summary}.

%package        callgraph
Summary:        Tool for reporting the call graph of a Go program

%description    callgraph
%{summary}.

%package        compilebench
Summary:        Benchmarks the speed of the Go compiler

%description    compilebench
%{summary}.

See https://pkg.go.dev/golang.org/x/tools/cmd/compilebench for more information.

%package        digraph
Summary:        Tool for queries over unlabelled directed graphs in text form

%description    digraph
The digraph command performs queries over unlabelled directed graphs
represented in text form.

%package        stringer
Summary:        Tool to automate creating methods satisfying the fmt.Stringer interface

%description    stringer
Stringer is a tool to automate the creation of methods that satisfy the
fmt.Stringer interface.

%package        godex
Summary:        Tool to dump exported information for Go packages or objects

%description    godex
The godex command prints (dumps) exported information of packages or selected
package objects.

See https://pkg.go.dev/golang.org/x/tools/cmd/godex for more information.

%package        benchcmp
Summary:        Displays performance changes between benchmarks for the Go programming language

%description    benchcmp
%{summary}.

See https://pkg.go.dev/golang.org/x/tools/cmd/benchcmp for more information.

%package        bundle
Summary:        Creates a single-source-file version of a source package

%description    bundle
%{summary}.

See https://pkg.go.dev/golang.org/x/tools/cmd/bundle for more information.

%package        eg
Summary:        Example-based refactoring for the Go programming language

%description    eg
%{summary}.

See `eg -help` for more information.

%package        file2fuzz
Summary:        Convert binary files to the Go fuzzing corpus format

%description    file2fuzz
%{summary}.

%package        fiximports
Summary:        Fixes import declarations to use the canonical import path

%description    fiximports
%{summary}.

%package        go-contrib-init
Summary:        Helps new Go contributors get their development environment set up

%description    go-contrib-init
The go-contrib-init command helps new Go contributors get their development
environment set up for the Go contribution process.

It aims to be a complement or alternative to
https://golang.org/doc/contribute.html.

%package        goimports
Summary:        Go programming language import line formatter

%description    goimports
%{summary}.

See https://pkg.go.dev/golang.org/x/tools/cmd/goimports for more information.

%package        gomvpkg
Summary:        Tool to move Go packages, updating import declarations

%description    gomvpkg
%{summary}.

See https://pkg.go.dev/golang.org/x/tools/cmd/gomvpkg for more information.

%package        gonew
Summary:        Tool to start a new Go module by copying a template module

%description    gonew
%{summary}.

See https://pkg.go.dev/golang.org/x/tools/cmd/gonew for more information.

%package        present
Summary:        Display slide presentations and articles

%description    present
%{summary}.

See https://pkg.go.dev/golang.org/x/tools/cmd/present for more information.

%package        present2md
Summary:        Tool to convert legacy-syntax present files to Markdown-syntax present files

%description    present2md
%{summary}.

See https://pkg.go.dev/golang.org/x/tools/cmd/present2md for more information.

%package        splitdwarf
Summary:        Uncompress and copy the DWARF segment of a Mach-O executable into the "dSYM" file

%description    splitdwarf
%{summary}.

See https://pkg.go.dev/golang.org/x/tools/cmd/splitdwarf for more information.

%package        ssadump
Summary:        Tool for displaying and interpreting the SSA form of Go programs

%description    ssadump
%{summary}.

%package        stress
Summary:        Tool for catching sporadic failures

%description    stress
%{summary}.

See https://pkg.go.dev/golang.org/x/tools/cmd/stress for more information.

%package        toolstash
Summary:        Provides a way to save, run, and restore a known good copy of the Go toolchain

%description    toolstash
%{summary}.

See https://pkg.go.dev/golang.org/x/tools/cmd/toolstash for more information.

%package        signature-fuzzer
Summary:        Utilities for fuzz testing of Go function signatures

%description    signature-fuzzer
%{summary}.

See https://pkg.go.dev/golang.org/x/tools/cmd/signature-fuzzer for more information.

%package        goyacc
Summary:        Goyacc is a version of yacc for Go

%description    goyacc
%{summary}.

See https://pkg.go.dev/golang.org/x/tools/cmd/goyacc for more information.
%endif

%gopkg

%prep
%goprep
%autopatch -p1
rm -rf gopls
find . -type f -name "*.go" -exec sed -i "s|mvdan.cc/xurls/v2|mvdan.cc/xurls|" "{}" +;

%if %{without bootstrap}
%generate_buildrequires
%go_generate_buildrequires
%endif

%if %{without bootstrap}
%build
for cmd in %auth_commands; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/cmd/auth/$cmd
done
for cmd in %signature_fuzzer; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/cmd/signature-fuzzer/$cmd
done
for cmd in %commands; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/cmd/$cmd
done
%endif

%install
%gopkginstall
%if %{without bootstrap}
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

# Fix conflict with rubygem-bundler
mv %{buildroot}%{_bindir}/bundle %{buildroot}%{_bindir}/gobundle
%endif

%if %{without bootstrap}
%if %{with check}
%check
%gocheck -t cmd -d imports -t internal/lsp -d go/pointer -d internal/imports -t gopls -d internal/packagesdriver -t go/packages -d go/analysis/unitchecker -d go/ssa -t internal/refactor
%endif
%endif

%if %{without bootstrap}
%files -n golang-godoc
%doc %{godocs}
%license %{golicenses}
%{_bindir}/godoc

%files -n golang-gotype
%doc %{godocs}
%license %{golicenses}
%{_bindir}/gotype

%files -n golang-html2article
%doc %{godocs}
%license %{golicenses}
%{_bindir}/html2article

%files    godex
%doc %{godocs}
%license %{golicenses}
%{_bindir}/godex

%files    auth
%doc %{godocs}
%license %{golicenses}
%{_bindir}/authtest
%{_bindir}/cookieauth
%{_bindir}/gitauth
%{_bindir}/netrcauth

%files    bisect
%doc %{godocs}
%license %{golicenses}
%{_bindir}/bisect

%files    callgraph
%doc %{godocs}
%license %{golicenses}
%{_bindir}/callgraph

%files    compilebench
%doc %{godocs}
%license %{golicenses}
%{_bindir}/compilebench

%files    digraph
%doc %{godocs}
%license %{golicenses}
%{_bindir}/digraph

%files    stringer
%doc %{godocs}
%license %{golicenses}
%{_bindir}/stringer

%files    eg
%doc %{godocs}
%license %{golicenses}
%{_bindir}/eg

%files    file2fuzz
%doc %{godocs}
%license %{golicenses}
%{_bindir}/file2fuzz

%files    fiximports
%doc %{godocs}
%license %{golicenses}
%{_bindir}/fiximports

%files    go-contrib-init
%doc %{godocs}
%license %{golicenses}
%{_bindir}/go-contrib-init

%files    benchcmp
%doc %{godocs}
%license %{golicenses}
%{_bindir}/benchcmp

%files    bundle
%doc %{godocs}
%license %{golicenses}
%{_bindir}/gobundle

%files    goimports
%doc %{godocs}
%license %{golicenses}
%{_bindir}/goimports

%files    gomvpkg
%doc %{godocs}
%license %{golicenses}
%{_bindir}/gomvpkg

%files    gonew
%doc %{godocs}
%license %{golicenses}
%{_bindir}/gonew

%files    present
%doc %{godocs}
%license %{golicenses}
%{_bindir}/present

%files    present2md
%doc %{godocs}
%license %{golicenses}
%{_bindir}/present2md

%files    splitdwarf
%doc %{godocs}
%license %{golicenses}
%{_bindir}/splitdwarf

%files    ssadump
%doc %{godocs}
%license %{golicenses}
%{_bindir}/ssadump

%files    stress
%doc %{godocs}
%license %{golicenses}
%{_bindir}/stress

%files    toolstash
%doc %{godocs}
%license %{golicenses}
%{_bindir}/toolstash

%files    signature-fuzzer
%doc %{godocs}
%license %{golicenses}
%{_bindir}/fuzz-driver
%{_bindir}/fuzz-runner

%files    goyacc
%doc %{godocs}
%license %{golicenses}
%{_bindir}/goyacc
%endif

%gopkgfiles


%changelog
* Mon Mar 24 2025 pterjan <pterjan> 0.29.0-1.mga10
+ Revision: 2169378
- Sync with Fedora
+ wally <wally>
- update RPM group to Development/Golang

* Sun Sep 25 2022 guillomovitch <guillomovitch> 0.1.12-2.mga9
+ Revision: 1892242
- fix gopls build

* Wed Aug 17 2022 guillomovitch <guillomovitch> 0.1.12-1.mga9
+ Revision: 1878381
- new version 0.1.12

* Sun Apr 03 2022 umeabot <umeabot> 0.1.9-2.mga9
+ Revision: 1841808
- Mageia 9 Mass Rebuild

* Wed Mar 02 2022 guillomovitch <guillomovitch> 0.1.9-1.mga9
+ Revision: 1787761
- new version 0.1.9
- non-bootstrap build

* Mon Nov 01 2021 guillomovitch <guillomovitch> 0.1.5-1.mga9
+ Revision: 1753577
- new version 0.1.5 (bootstrap build)

* Sun Aug 30 2020 guillomovitch <guillomovitch> 0-8.mga8
+ Revision: 1620220
- non-bootstrap build

* Sun Aug 30 2020 guillomovitch <guillomovitch> 0-7.mga8
+ Revision: 1619944
- really fix obsoletes tag

* Sun Aug 30 2020 guillomovitch <guillomovitch> 0-6.mga8
+ Revision: 1619930
- add obsoletes tag for devel package

* Sun Aug 30 2020 guillomovitch <guillomovitch> 0-5.mga8
+ Revision: 1619912
- renaming
- new snapshot
- rename to golang-x-tools

* Fri Feb 14 2020 umeabot <umeabot> 0-4.mga8
+ Revision: 1520312
- Mageia 8 Mass Rebuild

* Mon Nov 19 2018 pterjan <pterjan> 0-3.20181119gitce871d1.mga7
+ Revision: 1331612
- Disable bootstrap

* Mon Nov 19 2018 pterjan <pterjan> 0-2.20181119gitce871d1.mga7
+ Revision: 1331585
- Exclude some dependencies from the -devel package in bootstrap mode
- imported package golang-googlecode-tools

